package org.processmining.streamtransitionsystemsminer.plugins;

import org.processmining.contexts.uitopia.UIPluginContext;
import org.processmining.contexts.uitopia.annotations.UITopiaVariant;
import org.processmining.eventstream.core.interfaces.XSEventStream;
import org.processmining.eventstream.readers.acceptingpetrinet.XSEventStreamToAcceptingPetriNetReader;
import org.processmining.framework.plugin.PluginContext;
import org.processmining.framework.plugin.annotations.Plugin;
import org.processmining.framework.plugin.annotations.PluginVariant;
import org.processmining.stream.core.enums.CommunicationType;
import org.processmining.streamabstractrepresentation.parameters.UnCoupledAbstractionSchemeParametersImpl;
import org.processmining.streamabstractrepresentation.plugins.AbstractUncoupledStreamMinerDefaultDialogsPlugin;
import org.processmining.streamtransitionsystemsminer.algorithms.UncoupledSizeOneSetStreamTransitionSystemsMinerImpl;

@Plugin(name = "Discover Accepting Petri Net(s) (Transition Systems Miner)", parameterLabels = {
		"Event Stream" }, returnLabels = { "Transition Systems Miner (Event Stream)" }, returnTypes = {
				XSEventStreamToAcceptingPetriNetReader.class })
public class StreamTransitionSystemsMinerPlugin extends
		AbstractUncoupledStreamMinerDefaultDialogsPlugin<XSEventStreamToAcceptingPetriNetReader, UnCoupledAbstractionSchemeParametersImpl> {

	@UITopiaVariant(affiliation = UITopiaVariant.EHV, author = StreamTransitionSystemsMinerPluginInfo.AUTHOR, email = StreamTransitionSystemsMinerPluginInfo.EMAIL)
	@PluginVariant(requiredParameterLabels = { 0 })
	@Override
	public XSEventStreamToAcceptingPetriNetReader apply(UIPluginContext context, XSEventStream stream) {
		return super.apply(context, stream);
	}

	protected UnCoupledAbstractionSchemeParametersImpl getFreshParameters(PluginContext context) {
		return new UnCoupledAbstractionSchemeParametersImpl();
	}

	protected XSEventStreamToAcceptingPetriNetReader constructReader(PluginContext context, CommunicationType comm,
			UnCoupledAbstractionSchemeParametersImpl parameters) {
		return new UncoupledSizeOneSetStreamTransitionSystemsMinerImpl(context, parameters);
	}

}
